; CL-DBMS by Zerosum
; $Id: 
;
; * A database that has one or more tablespaces
;


(load "db-create.lisp")
(load "env.lisp")
(load "ts.lisp")

; Initialize the database system
(defun db-initialize()
  (load "db-property.lisp")
)

; Create a database 
;
; With an environment, env
; Return the created database
(defun db-create( env ) 
  (db-create-db-anchor env)
  (db-create-system-tablespace env)
  (db-create-data-tablespace env)
  (db-create-temp-tablespace env)

  (db-create-log-files env)
)

; Drop a database, db
(defun db-drop( db ) 
  (db-drop-system-tablespace env)
)

; Open a database
; Return the opened database
(defun db-open( env ) 
)

; Close a database
(defun db-close( env db ) 
)

; Create a tablepsace
;
; Within a file named, ts-file-pathname
; With initial size, init-size
; With extent size, ext-size
;
; 1. Create a tablespace,
; 2. Add the tablespace into the db
(defun db-create-tablespace ( tx db ts-file-pathname init-size ext-size )
  ( ts-create tx db init-size ext-size )
)

; Drop a tablespace
;
; 1. Remove the tablespace from the db
; 2. Drop the tablespace
(defun db-drop-tablespace ( tx db tablespace )
)

; Get a default data tablespace 
(defun db-default-data-ts (env db)
)

; Create a table
;
; On a tablespace, ts
; With a column specification, column-spec
(defun db-create-table( tx db ts column-spec) 
  ( ts-create-table tx ts column-spec )
)

; Drop a table, table
;
; On a tablespace, ts
(defun db-drop-table( tx db ts table ) 
  ( ts-drop-table tx ts table )
)

; Open a cursor on a table, table

; Within a tablespace, ts
; With a scan condition, scan-condition
(defun db-open-table-cursor( tx db ts table scan-condition ) 
  ( ts-open-table-cursor tx ts table scan-condition )
)

; Close an opened cursor on a table, table
; 
; Within a tablespace, ts
(defun db-close-table-cursor( tx db ts table cursor )
  ( ts-close-table-cursor tx ts cursor )
)
